// AddEvent.cpp : implementation file
//

#include "stdafx.h"
#include "Reminder.h"
#include "ReminderDoc.h"
#include "ReminderView.h"
#include "AddEvent.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString DataFile;
/////////////////////////////////////////////////////////////////////////////
// CAddEvent dialog


CAddEvent::CAddEvent(CWnd* pParent /*=NULL*/)
	: CDialog(CAddEvent::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddEvent)
	m_Notify = 0;
	//}}AFX_DATA_INIT

}


void CAddEvent::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddEvent)
	DDX_Control(pDX, IDC_YEARLY_CHECK, m_Yearly);
	DDX_Control(pDX, IDC_DATE, m_Date);
	DDX_Control(pDX, IDC_NAME, m_Name);
	DDX_Text(pDX, IDC_NOTIFY, m_Notify);
	DDV_MinMaxUInt(pDX, m_Notify, 0, 100);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddEvent, CDialog)
	//{{AFX_MSG_MAP(CAddEvent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddEvent message handlers

void CAddEvent::OnOK() 
{
	// TODO: Add extra validation here
	if(AddEvent() )
		CDialog::OnOK();
}

BOOL CAddEvent::OnInitDialog() 
{
	CDialog::OnInitDialog();
	// TODO: Add extra initialization here
	COleDateTime Now = COleDateTime::GetCurrentTime() ;
	m_Yearly.SetCheck(1);	
	m_Notify = 5;
	m_Date.SetFormat(_T("MMMM dd, yyyy"));
	m_Date.SetTime( Now );
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CAddEvent::AddEvent()
{
	Event Record;
	Header Head;
	CString EventName;
	WORD Length;

	SYSTEMTIME TimeDest;
	m_Name.GetWindowText(EventName);
	Length = EventName.GetLength();
	if(!Length)
	{
		MessageBox("Event's name cannot be blank!", "Error",MB_ICONERROR | MB_OK);
		return FALSE;
	}
	UpdateData(TRUE);
	m_Date.GetTime(&TimeDest);
	Record.Year		= TimeDest.wYear;
	Record.Month	= TimeDest.wMonth;
	Record.Day		= TimeDest.wDay;
	Record.Yearly = m_Yearly.GetCheck();
	COleDateTime Now = COleDateTime::GetCurrentTime();
	int Year = Now.GetYear();
	int Month = Now.GetMonth();
	int Day = Now.GetDay();
	if( !Record.Yearly && (Year > Record.Year || 
			(Year == Record.Year && Month > Record.Month ) ||
			(Year == Record.Year && Month == Record.Month && Day > Record.Day) ) )
	{
		MessageBox("A one-time event cannot be a past event!", "Error",MB_ICONERROR|MB_OK);
		return FALSE;
	}
	
	Record.Disabled = 0;
	Record.Notify = m_Notify;
	Record.Reserved = 0;
	FILE *DataBase;
	DataBase = fopen(DataFile,"r+b");
	if(DataBase == 0 )
	{
		DataBase = fopen(DataFile,"wb");
		if( DataBase == 0 )
		{
			MessageBox("Unable to open file", "Error",MB_ICONERROR|MB_OK);
			return FALSE;
		}
	}
	fseek( DataBase, 0, SEEK_END );
	if( ftell(DataBase) == 0 )
	{
		Head.Identifier1 = 'R';
		Head.Identifier2 = 'M';
		Head.Marker = 0x0106AA02;
		Head.Version = 2;
		fwrite(&Head, 1, sizeof(Head), DataBase);		
	}
	Length++;
	fwrite(&Length, 1, sizeof(Length), DataBase);
	fwrite((LPCSTR)EventName, 1, Length, DataBase);
	fwrite(&Record, 1, sizeof(Record), DataBase);
	fclose(DataBase);
	return TRUE;
}
