// EditEvent.cpp : implementation file
//

#include "stdafx.h"
#include "Reminder.h"
#include "EditEvent.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditEvent dialog


CEditEvent::CEditEvent(Event * Rec, CString* Name, CWnd* pParent)
	: CDialog(CEditEvent::IDD, pParent)
{
	Record = Rec;
	EventName = Name;
	//{{AFX_DATA_INIT(CEditEvent)
	m_Notify = 0;
	//}}AFX_DATA_INIT
}


void CEditEvent::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditEvent)
	DDX_Control(pDX, IDC_NAME, m_Name);
	DDX_Control(pDX, IDC_YEARLY_CHECK, m_Yearly);
	DDX_Control(pDX, IDC_DATE, m_Date);
	DDX_Text(pDX, IDC_NOTIFY, m_Notify);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditEvent, CDialog)
	//{{AFX_MSG_MAP(CEditEvent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditEvent message handlers

BOOL CEditEvent::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_Name.SetWindowText(*EventName);
	m_Yearly.SetCheck(Record->Yearly);
	//Year = Record->Year;	// + Record->Adjustment;
	COleDateTime RecTime( Record->Year, Record->Month, Record->Day,0,0,0);
	m_Date.SetFormat(_T("MMMM dd, yyyy"));


	m_Notify = Record->Notify;
	m_Date.SetTime( RecTime );
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEditEvent::OnOK() 
{
	// TODO: Add extra validation here
	SYSTEMTIME TimeDest;
	m_Name.GetWindowText(*EventName);

	if( EventName->GetLength() == 0  )
	{
		MessageBox("Event's name cannot be blank!", "Error",MB_ICONERROR | MB_OK);
		return ;
	}

	UpdateData(TRUE);
	m_Date.GetTime(&TimeDest);
	Record->Year		= TimeDest.wYear;
	Record->Month	= TimeDest.wMonth;
	Record->Day		= TimeDest.wDay;
	Record->Yearly = m_Yearly.GetCheck();

	COleDateTime Now = COleDateTime::GetCurrentTime();
	int Year = Now.GetYear();
	int Month = Now.GetMonth();
	int Day = Now.GetDay();
	if( !Record->Yearly && (Year > Record->Year || 
			(Year == Record->Year && Month > Record->Month ) ||
			(Year == Record->Year && Month == Record->Month && Day > Record->Day) ) )
	{
		MessageBox("A one-time event cannot be a past event!", "Error",MB_ICONERROR|MB_OK);
		return ;
	}
	Record->Notify = m_Notify;
	Record->Reserved = 0;
	CDialog::OnOK();
}
