// Events.cpp: implementation of the CEvents class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Reminder.h"
#include "Events.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define DATE			1
#define DAYS_LEFT		2
#define NOTIFICATION	3
#define DISABLED		4
#define RECCURENCE		5

extern CReminderApp theApp;
extern CString DataFile;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEvents::CEvents(BOOL A)
{
	All = A;
	m_List = NULL;
	Ascending = TRUE;
	SortHeader = DAYS_LEFT;
	ReEvaluate();
}

CEvents::~CEvents()
{

}

WORD CEvents::ReadConfig()
{
	//Version 2 specific
	WORD Length;
	Header Head;	
	Event RecordV2;
	CString EventName;
	LPTSTR NameBuffer;
	
	FILE *DataBase;
	WORD Count = 0;
	int Year;
	int Month;
	int Day;
	long int DaysLeft;
	int Counter = -1;
	CString Temp;

	m_List->AssertValid();
	COleDateTime T = COleDateTime::GetCurrentTime();
	COleDateTime Now( T.GetYear(), T.GetMonth(), T.GetDay(),0,0,0 );
	m_List->DeleteAllItems();
	DataBase = fopen(DataFile,"rb");
	if(DataBase == 0 )
	{
		return FALSE;
	}
	//Checking if Database is of Version 2
	
	fread(&Head, 1, sizeof(Header), DataBase);
	if( 
		Head.Identifier1 == 'R' &&
		Head.Identifier2 == 'M' &&
		Head.Marker == 0x0106AA02 )
	{
		//Version 2 or above
//		AfxMessageBox("Version 2 ");
		if(Head.Version > 2 )
		{
			AfxMessageBox("Database is of higher version than expected./n Attempting to read anyway");
		}
		while (1)
		{
			//Reading a variable length record...
			if(!fread(&Length, 1, sizeof(WORD), DataBase))
					break;
			NameBuffer = EventName.GetBuffer(Length+1);
			fread(NameBuffer, 1, Length, DataBase);
			fread(&RecordV2, 1, sizeof(RecordV2), DataBase);
			EventName.ReleaseBuffer(Length);
			Counter ++;
			//Days Left DAYS_LEFT
			Year = Now.GetYear();
			Month = Now.GetMonth();
			Day = Now.GetDay();
			if( Year < RecordV2.Year)
				Year = RecordV2.Year;
			else
			{
				if( ( RecordV2.Month < Month ) || 
					( Month == RecordV2.Month && RecordV2.Day < Now.GetDay() ) )
					Year ++;
			}
	
			COleDateTime TempTime(Year, RecordV2.Month, RecordV2.Day,0,0,0);
			COleDateTimeSpan TimeDiff =  TempTime - Now;
			DaysLeft = TimeDiff.GetDays();
			if(!All && (DaysLeft > RecordV2.Notify || RecordV2.Disabled) )
			{
				continue;
			}
			m_List->InsertItem( Count,EventName);
			m_List->SetItemData(Count,Counter);
			Temp.Format("%2d-%2d-%4d",RecordV2.Day,RecordV2.Month,RecordV2.Year );	
			m_List->SetItemText(Count,DATE,Temp);	//Date
			if (RecordV2.Yearly)
				m_List->SetItemText(Count,RECCURENCE,"Yearly");
			else
				m_List->SetItemText(Count,RECCURENCE,"One Time Event");
		
			if(RecordV2.Disabled)
				m_List->SetItemText(Count,DISABLED,"Disabled");
			else
				m_List->SetItemText(Count,DISABLED,"Enabled");
			Temp.Format("%d days",RecordV2.Notify);
				m_List->SetItemText(Count,NOTIFICATION,Temp);	//Notification
		
			if( DaysLeft )
				Temp.Format("%ld",DaysLeft);
			else
				Temp = "None.";
			m_List->SetItemText(Count,DAYS_LEFT,Temp);	//Notification
			Count ++;
		}
		
	}
	//Version 1 - Improbable should have been converted to version 2
	else 
	{
		AfxMessageBox("\nInvalid Datafile encountered");
		return 0;
	}
	fclose(DataBase);
	Sort( SortHeader );
	if(All)
	{
		AfxGetMainWnd()->PostMessage(WM_USER,0,Count);
	}
	return Count;
}

BOOL CEvents::EnableEvents(BOOL Status)
{
	m_List->AssertValid();
	FILE *DataBase;
	Event Record;
	CString Temp;
	WORD Length;
	CString EventName;
	LPTSTR NameBuffer;
	long s = sizeof(Event);
	int Selection = 0;
	int Count = m_List->GetItemCount( );
	DataBase = fopen(DataFile, "r+b" );
	if( !DataBase )
	{
		AfxMessageBox("Unable to open database");
		return FALSE;
	}
	int RealIndex = 0;
	for( int i = 0; i < Count ; i++ )
	{
		
		if(m_List->GetItemState(i ,LVIS_SELECTED)==LVIS_SELECTED)
		{
			Selection = i;
			RealIndex = m_List->GetItemData( i );
			//Jumping past the header...
			fseek(DataBase, sizeof(Header), SEEK_SET);
			//Seeking the selected Record
			for (int j = 0 ; j <= RealIndex ; j++)
			{
				
				fread(&Length, 1, sizeof(WORD), DataBase);
				
				NameBuffer = EventName.GetBuffer(Length+1);
				fread(NameBuffer, 1, Length, DataBase);
				EventName.ReleaseBuffer(Length);
				fread(&Record, 1, sizeof(Record), DataBase);
					
			}
			fseek(DataBase, -s, SEEK_CUR);
			Record.Disabled = !Status;	
			fwrite(&Record,s,1,DataBase);
		}
	}
	fclose(DataBase);
	ReadConfig();
	m_List->SetItemState(Selection, LVIS_SELECTED, LVIS_SELECTED);	
	m_List->EnsureVisible( Selection, FALSE);
	return TRUE;
}

void CEvents::SetListCtrl(CListCtrl *List)
{
	m_List = List;
}

BOOL CEvents::ReEvaluate()
{

	int Year;
	int Month;
	int Day;
	long int DaysLeft;
	

	WORD Length;
	Header Head;	
	CString EventName;
	LPTSTR NameBuffer;

	FILE *DataBase, *Backup;

	COleDateTime Now = COleDateTime::GetCurrentTime();
	DataBase = fopen(DataFile, "rb" );
	Backup   = fopen("Temp.bak"  , "wb"  );
	if( !DataBase || !Backup)
	{
		return FALSE;
	}
	int i = 0;

	//Checking if Database is of Version 2
	fread(&Head, 1, sizeof(Header), DataBase);
	if( 
		Head.Identifier1 == 'R' &&
		Head.Identifier2 == 'M' &&
		Head.Marker == 0x0106AA02 )
	{
		Event RecordV2;
		fwrite(&Head, 1, sizeof(Head), Backup);
		while( 1 )
		{
			//Reading a variable length record...
			if(!fread(&Length, 1, sizeof(WORD), DataBase))
				break;
			NameBuffer = EventName.GetBuffer(Length+1);
			if(!fread(NameBuffer, 1, Length, DataBase))
				break;
			EventName.ReleaseBuffer(Length);

			if(!fread(&RecordV2, 1, sizeof(RecordV2), DataBase))
				break;

			Year = Now.GetYear();
			Month = Now.GetMonth();
			Day = Now.GetDay();
			if( !RecordV2.Yearly && Year > RecordV2.Year || 
				(Year == RecordV2.Year && Month > RecordV2.Month ) ||
				(Year == RecordV2.Year && Month == RecordV2.Month && Day > RecordV2.Day) )
				continue;
			if( Year < RecordV2.Year)
				Year = RecordV2.Year;
			else
			{
				if( ( RecordV2.Month < Month ) || 
					( Month == RecordV2.Month && RecordV2.Day < Now.GetDay() ) )
					Year ++;
			}
	
			COleDateTime TempTime(Year, RecordV2.Month, RecordV2.Day,0,0,0);
			COleDateTimeSpan TimeDiff =  TempTime - Now;
			DaysLeft = TimeDiff.GetDays();
			if( DaysLeft > 100 )
				RecordV2.Disabled = FALSE;
			fwrite(&Length, 1, sizeof(WORD), Backup);
			fwrite(NameBuffer, 1, Length, Backup);
			fwrite(&RecordV2,sizeof(Event),1,Backup);
		}
	}
	else
	{
		AfxMessageBox("\nInvalid Datafile encountered");
		return 0;
		//**********	Code for evaluating a Version 1 Database. 
		//**********	Not Required anymore
		/*		
		Event1  Record;	
		fseek(DataBase, 0, SEEK_SET);
		while( 1 )
		{
			if(!fread(&Record, sizeof(Event1),1, DataBase) )
				break;
			Year = Now.GetYear();
			Month = Now.GetMonth();
			Day = Now.GetDay();
			if( !Record.Yearly && Year > Record.Year || 
				(Year == Record.Year && Month > Record.Month ) ||
				(Year == Record.Year && Month == Record.Month && Day > Record.Day) )
				continue;
			if( Year < Record.Year)
				Year = Record.Year;
			else
			{
				if( ( Record.Month < Month ) || 
					( Month == Record.Month && Record.Day < Now.GetDay() ) )
					Year ++;
			}
	
			COleDateTime TempTime(Year, Record.Month, Record.Day,0,0,0);
			COleDateTimeSpan TimeDiff =  TempTime - Now;
			DaysLeft = TimeDiff.GetDays();
			if( DaysLeft > 100 )
				Record.Disabled = FALSE;
			fwrite(&Record,sizeof(Event1),1,Backup);
		}
		*/
	}
	fclose(DataBase);
	fclose(Backup);
	unlink(DataFile);
	rename("Temp.bak",DataFile);	
	return TRUE;
}

BOOL CEvents::Sort(BYTE Header)
{
	m_List->AssertValid();
	if( Header == DAYS_LEFT )
	{
		if(Ascending)
			m_List->SortItems( CEvents::SortDaysLeftAsc, (LPARAM)m_List);
		else
			m_List->SortItems( CEvents::SortDaysLeftDec, (LPARAM)m_List);
	}

	else if ( Header == 0 )
	{
		if(Ascending)
			m_List->SortItems( CEvents::SortNameAsc, (LPARAM)m_List);
		else
			m_List->SortItems( CEvents::SortNameDec, (LPARAM)m_List);
	}
	SortHeader = Header;
	return TRUE;
}

int CALLBACK CEvents::SortDaysLeftAsc(LPARAM lParam1, LPARAM lParam2, LPARAM lpListCtrl)
{
	CListCtrl *pList = (CListCtrl *)lpListCtrl;
	int one, two, ret = 0, ItemData, Count;
	CString Temp;
	pList->AssertValid();
	Count = pList->GetItemCount();
	for( int i=0; i < Count; i++ )
	{
		ItemData = pList->GetItemData( i );
		if( ItemData == lParam1)
		{
			Temp = pList->GetItemText( i, 2);
			one = atoi( (LPCSTR) Temp);
		}
		else if( ItemData == lParam2)
		{
			Temp = pList->GetItemText( i, 2);
			two = atoi( (LPCSTR) Temp);
		}
	}
	if( one > two )
		ret = 1;
	else if( one < two)
		ret = -1;
	return ret;
}

int CALLBACK CEvents::SortDaysLeftDec(LPARAM lParam1, LPARAM lParam2, LPARAM lpListCtrl)
{
	return - (SortDaysLeftAsc(lParam1, lParam2, lpListCtrl));
}

int CALLBACK CEvents::SortNameAsc(LPARAM lParam1, LPARAM lParam2, LPARAM lpListCtrl)
{
	CListCtrl *pList = (CListCtrl *)lpListCtrl;
	int ret = 0, ItemData, Count;
	CString One, Two;
	pList->AssertValid();
	Count = pList->GetItemCount();
	for( int i=0; i < Count; i++ )
	{
		ItemData = pList->GetItemData( i );
		if( ItemData == lParam1)
		{
			One = pList->GetItemText(i, 0);
			
		}
		else if( ItemData == lParam2)
		{
			Two = pList->GetItemText( i, 0);
		}
	}
	return One.CompareNoCase(Two);
}

int CALLBACK CEvents::SortNameDec(LPARAM lParam1, LPARAM lParam2, LPARAM lpListCtrl)
{
	return - (SortNameAsc(lParam1, lParam2, lpListCtrl));
}

void CEvents::SetSortOrder(BOOL Order)
{
	Ascending = Order;
}

BOOL CEvents::ConvertToVersion2(CString &OldDataFile, CString &NewDataFile)
{
	//Variables for conversion from Version 1 to Version 2
	FILE *TempFile, *DataBase;
	CString TempFileName = OldDataFile + ".bak";
	CString BackupFileName = OldDataFile + ".Old";
	
	//Version 2 specific
	WORD Length;
	Header Head;	
	CString EventName;
	Event1 Record;
	Event RecordV2;

	if( GetVersion( OldDataFile ) == 1 )
	{
		AfxMessageBox("Database is of Version 1\nAttempting to convert to Version 2");
	}
	else
		return 0;
	//Checking if Database is of Version 2
	Head.Identifier1 = 'R';
	Head.Identifier2 = 'M';
	Head.Marker = 0x0106AA02;
	Head.Version = 2;
	Length = 20;
	
	DataBase = fopen(OldDataFile,"rb");
	if( !DataBase )
		return FALSE;
	TempFile = fopen(TempFileName ,"wb");
	if( !TempFile )
		return FALSE;
	fwrite(&Head, 1, sizeof(Head), TempFile);
	while(fread(&Record, 1, sizeof(Record), DataBase) )
	{
		RecordV2.Day	= Record.Day;
		RecordV2.Month	= Record.Month;
		RecordV2.Year	= Record.Year;
		RecordV2.Yearly	= Record.Yearly;
		RecordV2.Notify	= Record.Notify;
		RecordV2.Disabled	= Record.Disabled;
		RecordV2.Reserved	= 0; 
		fwrite(&Length, 1, sizeof(WORD), TempFile);
		fwrite(Record.Name, 1, Length, TempFile);
		fwrite(&RecordV2, 1, sizeof(Event), TempFile);
	}
	fclose(TempFile);
	fclose(DataBase);
	_unlink(BackupFileName);
	rename(OldDataFile, BackupFileName);
	rename(TempFileName, NewDataFile);
	return TRUE;
}

WORD CEvents::GetVersion(CString &DataBaseFile)
{
	FILE * DataBase;
	Header Head;
	DataBase = fopen(DataBaseFile,"rb");
	if(DataBase == 0 )
	{
//		AfxMessageBox("Open Failure");
		return FALSE;
	}
	//Checking if Database is of Version 2
	int ReadSuccess = fread(&Head, 1, sizeof(Header), DataBase) ;
	fclose( DataBase );

	if( !ReadSuccess )
	{
//		AfxMessageBox("Read Failure");
		return 0;
	}
	else if (
		Head.Identifier1 == 'R' &&
		Head.Identifier2 == 'M' &&
		Head.Marker == 0x0106AA02 )
	{
		//Already version 2
		return Head.Version;
	}
	else
		return 1;
}