// Reminder.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Reminder.h"
#include "Remind.h"
#include "MainFrm.h"
#include "ReminderDoc.h"
#include "ReminderView.h"
#include <Regstr.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CReminderApp

BEGIN_MESSAGE_MAP(CReminderApp, CWinApp)
	//{{AFX_MSG_MAP(CReminderApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReminderApp construction

CReminderApp::CReminderApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	DontRemind = FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CReminderApp object

CReminderApp theApp;
CString DataFile;

/////////////////////////////////////////////////////////////////////////////
// CReminderApp initialization

BOOL CReminderApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.
	
#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Purayidam Software"));

	LoadStdProfileSettings(0);  // Load standard INI file options (including MRU)
	
// Checking Database...
	CString OldDataFile, CmdLine, StrTemp;
	CmdLine = GetCommandLine();
	//AfxMessageBox( CmdLine );
	//Generating Database Names
	
	for( int i = 1; CmdLine[i] != '\0' && CmdLine[i] != '"'; i++)
		StrTemp += CmdLine[i];
	
	int Count = StrTemp.GetLength();
	OldDataFile =  StrTemp.Left( Count - 3 ) + "dat";
	DataFile    =  StrTemp.Left( Count - 4 ) + "2.dat";
	//AfxMessageBox( DataFile + " \r\n" + OldDataFile);

	int Version = CEvents::GetVersion( DataFile );
	if( !Version )
	{
		Version = CEvents::GetVersion( OldDataFile );
		if( Version == 1 )
		{
			CEvents::ConvertToVersion2(OldDataFile,DataFile );
		}
		else if ( Version == 2 )
		{
			// Unlikely but handled anyway
			rename( OldDataFile,DataFile );
		}
	}
	else if (Version == 1 )
	{
		// Unlikely but handled anyway
		CEvents::ConvertToVersion2( DataFile, OldDataFile );
		rename( OldDataFile,DataFile );
	}
	DontRemind = GetProfileInt("Settings","DontRemind", 0);
	if( CmdLine.Find("/R") != -1 || CmdLine.Find("/r") != -1 ) 
	{
		//Remind only. Do not display Main Window
		//Display only Reminder Dialog Box
		if( DontRemind )
			return FALSE;
		CRemind Reminder;
		if ( Reminder.DoModal() != IDC_APP )
			return FALSE;
	}
	else
		CmdLine += " /R";
	AutoRunCommand = CmdLine;
	
	HKEY hKey;
	DWORD Disposition;
	if(RegCreateKeyEx(HKEY_CURRENT_USER,"Software\\Microsoft\\Windows\\CurrentVersion\\Run",
		0,"",REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,&Disposition)==ERROR_SUCCESS)
	{
			//Writing to registry so that Reminder 2.0 will autorun on startup
		if( DontRemind )
		{
			RegDeleteValue (hKey, "Reminder" ); 
		}
		else
		{
			RegSetValueEx(hKey,"Reminder",0, REG_SZ,(const unsigned char *)(LPCSTR)CmdLine,CmdLine.GetLength());
		}
		//Deleting subkey Reminder
		//This is done to fix a bug in an earlier version 
		RegDeleteKey (hKey, "Reminder" ); 
		RegCloseKey(hKey);	
	}
	else
	{
		AfxMessageBox("Unable to create registry entry");
	}
	//Deleting old Configuration used by previous version...
	if(RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\Purayidam Software\\Reminder",
		0,"",REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,&Disposition)==ERROR_SUCCESS)
	{
		RegDeleteKey (hKey, "Configuration" );
		RegCloseKey(hKey);
	}

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CReminderDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CReminderView));
	AddDocTemplate(pDocTemplate);
	
	
	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	
	//	m_pMainWnd->ShowWindow(SW_SHOW);
	//	m_pMainWnd->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_Licensee;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_Licensee = _T("");
	//}}AFX_DATA_INIT
	
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_LICENSEE, m_Licensee);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CReminderApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CReminderApp message handlers


int CReminderApp::ExitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CWinApp::ExitInstance();
}


DWORD CReminderApp::DateEncode()
{
	int Date;
	CTime Time = CTime::GetCurrentTime();
	Date = Time.GetDay();
	Date += 100 * Time.GetMonth();
	Date += 10000 * Time.GetYear();
	return Date;
}


BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	HKEY hKey;
	char str[100];
	unsigned long size = 100;
	LONG ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE,"Software\\Microsoft\\Windows\\CurrentVersion",
					   0,KEY_QUERY_VALUE,&hKey);
	if(ret == ERROR_SUCCESS)
	{
		ret = RegQueryValueEx(hKey,"RegisteredOwner",0,NULL,(BYTE *)str,&size);
		RegCloseKey(hKey);	
	}
	if( ret != ERROR_SUCCESS )
	{
		ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion",
						   0,KEY_QUERY_VALUE,&hKey);
		if( ret ==ERROR_SUCCESS )
		{
			ret = RegQueryValueEx(hKey,"RegisteredOwner",0,NULL,(BYTE *)str,&size);
			RegCloseKey(hKey);	
		}
	}
	if( ret == ERROR_SUCCESS )
	{
		m_Licensee = str;
	}

	UpdateData(FALSE);
	return TRUE;
}

