// ReminderView.cpp : implementation of the CReminderView class
//

#include "stdafx.h"
#include "Reminder.h"

#include "ReminderDoc.h"
#include "ReminderView.h"
#include "EditEvent.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DATE			1
#define DAYS_LEFT		2
#define NOTIFICATION	3
#define DISABLED		4
#define RECCURENCE		5

extern CReminderApp theApp;
extern CString DataFile;
/////////////////////////////////////////////////////////////////////////////
// CReminderView

IMPLEMENT_DYNCREATE(CReminderView, CListView)

BEGIN_MESSAGE_MAP(CReminderView, CListView)
	//{{AFX_MSG_MAP(CReminderView)
	ON_COMMAND(ID_ADDEVENT, OnFileAddevent)
	ON_COMMAND(ID_DELETEEVENT, OnFileDeleteevent)
	ON_COMMAND(ID_REMIND, OnEventsRemind)
	ON_UPDATE_COMMAND_UI(ID_REMIND, OnUpdateEventsRemind)
	ON_COMMAND(ID_DISABLE, OnEventsDontRemind)
	ON_UPDATE_COMMAND_UI(ID_DISABLE, OnUpdateEventsDontRemind)
	ON_COMMAND(ID_EDITEVENT, OnEditevent)
	ON_UPDATE_COMMAND_UI(ID_EDITEVENT, OnUpdateEditevent)
	ON_UPDATE_COMMAND_UI(ID_DELETEEVENT, OnUpdateDeleteevent)
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnclick)
	ON_COMMAND(ID_DONTREMIND, OnDontremind)
	ON_UPDATE_COMMAND_UI(ID_DONTREMIND, OnUpdateDontremind)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReminderView construction/destruction

CReminderView::CReminderView():Events(TRUE) //All Events Displayed
{
	// TODO: add construction code here
	Ascending = 0;
	LastHeader = DAYS_LEFT;
}

CReminderView::~CReminderView()
{
}

BOOL CReminderView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CListView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CReminderView drawing

void CReminderView::OnDraw(CDC* pDC)
{
	CReminderDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

void CReminderView::OnInitialUpdate()
{
	CListView::OnInitialUpdate();
	CRect Rect;
	GetWindowRect(&Rect);
	Events.SetListCtrl( &( GetListCtrl() ) );
	GetListCtrl( ).InsertColumn( 0, "Event",LVCFMT_LEFT,(Rect.right - Rect.left )/3);
	GetListCtrl( ).InsertColumn( 1, "Date",LVCFMT_LEFT,(Rect.right - Rect.left )/8);	
	GetListCtrl( ).InsertColumn( 2, "Days Left",LVCFMT_LEFT,(Rect.right - Rect.left )/10);
	GetListCtrl( ).InsertColumn( 3, "Notificatin",LVCFMT_LEFT,(Rect.right - Rect.left )/8);	
	GetListCtrl( ).InsertColumn( 4, "Status",LVCFMT_LEFT,(Rect.right - Rect.left )/10);	
	GetListCtrl( ).InsertColumn( 5, "Recurrence",LVCFMT_LEFT,(Rect.right - Rect.left )/6);	
	ModifyStyle(LVS_TYPEMASK,LVS_REPORT & LVS_TYPEMASK);
	GetListCtrl().SetExtendedStyle(LVS_EX_FULLROWSELECT |LVS_EX_GRIDLINES );
	Events.ReadConfig();
	// TODO: You may populate your ListView with items by directly accessing
	//  its list control through a call to GetListCtrl().
}

/////////////////////////////////////////////////////////////////////////////
// CReminderView diagnostics

#ifdef _DEBUG
void CReminderView::AssertValid() const
{
	CListView::AssertValid();
}

void CReminderView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}

CReminderDoc* CReminderView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CReminderDoc)));
	return (CReminderDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CReminderView message handlers

void CReminderView::OnFileAddevent() 
{
	// TODO: Add your command handler code here
	AddEvent.DoModal();
	Events.ReadConfig();
}

void CReminderView::OnFileDeleteevent() 
{
	// TODO: Add your command handler code here
	FILE *DataBase;
	Event Record;
	CString EventName;
	CString Temp;
	Header Head;
	WORD Length;	
	
	Head.Identifier1 = 'R';
	Head.Identifier2 = 'M';
	Head.Marker = 0x0106AA02;
	Head.Version = 2;
	DataBase = fopen(DataFile,"wb");
	fwrite(&Head, 1, sizeof(Head), DataBase );
	GetListCtrl().LockWindowUpdate( );

	int Count = GetListCtrl().GetItemCount( );
	for( int i = 0; i<Count; )
	{
		if(GetListCtrl().GetItemState(i,LVIS_SELECTED) == LVIS_SELECTED)
		{
			GetListCtrl().DeleteItem(i);
			Count--;
		}
		else
		{
			EventName = GetListCtrl().GetItemText(i,0);
			Length = EventName.GetLength() + 1;

			Temp = GetListCtrl().GetItemText(i,DATE);//Date
			sscanf( (LPCTSTR)Temp,"%2d-%2d-%4d",&Record.Day,&Record.Month,&Record.Year);
			Temp = GetListCtrl().GetItemText(i,RECCURENCE);//Yearly
			if(Temp.Compare("Yearly") == 0)
				Record.Yearly = 1;
			else
				Record.Yearly = 0;
			Temp = GetListCtrl().GetItemText(i,NOTIFICATION);
			sscanf( (LPCTSTR)Temp,"%d",&Record.Notify);
			Temp = GetListCtrl().GetItemText(i,DISABLED);
			if( Temp.Compare("Disabled") )
				Record.Disabled = 0;	
			else
				Record.Disabled = 1;	

			//Write to Database
			fwrite(&Length,1,sizeof(Length),DataBase);
			fwrite( (LPCSTR)EventName ,1,Length,DataBase);
			fwrite(&Record,1,sizeof(Event),DataBase);
			i++;
		}
	}
	fclose(DataBase);
	GetListCtrl().UnlockWindowUpdate( );
	AfxGetMainWnd()->PostMessage(WM_USER,0,Count);
}

void CReminderView::OnEventsRemind() 
{
	// TODO: Add your command handler code here
	Events.EnableEvents(TRUE);
}

void CReminderView::OnUpdateEventsRemind(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if( GetListCtrl().GetSelectedCount() == 0 )
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);
}

void CReminderView::OnEventsDontRemind() 
{
	// TODO: Add your command handler code here
	Events.EnableEvents(FALSE);
}

void CReminderView::OnUpdateEventsDontRemind(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if( GetListCtrl().GetSelectedCount() == 0 )
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);
}


void CReminderView::OnEditevent() 
{
	// TODO: Add your command handler code here
	
	FILE *DataBase, *OldDatFile;
	Event Record;
	CString Temp;
	CString EventName;
	LPSTR NameBuffer;
	WORD Length;
	Header Head;	
	BOOL Modified = FALSE;
	

	POSITION Pos;

	int Count = GetListCtrl().GetItemCount( );
	if( Count == 0 )
		return;

	Pos = GetListCtrl().GetFirstSelectedItemPosition();
	int Selection = GetListCtrl().GetNextSelectedItem( Pos );
	int RealIndex = GetListCtrl().GetItemData( Selection );

	// Copying Database to temporary file...
	CString TempFileName = DataFile + ".bak";
	_unlink(TempFileName);
	rename(DataFile, TempFileName );


	DataBase = fopen (DataFile,"wb");
	OldDatFile = fopen (TempFileName,"rb");

	//Jumping past the header...
	fread  ( &Head, 1, sizeof(Header), OldDatFile);
	fwrite ( &Head, 1, sizeof(Header), DataBase);	
	
	for( int i = 0; i<Count; i++)
	{
		//Seeking the next Record
		fread (&Length, 1, sizeof(WORD), OldDatFile);
		NameBuffer = EventName.GetBuffer(Length+1);
		fread (NameBuffer, 1, Length, OldDatFile);
		EventName.ReleaseBuffer(Length);
		fread (&Record, 1, sizeof(Record), OldDatFile);
		
		if( i == RealIndex )
		{
			CEditEvent EditEvent(&Record, &EventName);
			if( EditEvent.DoModal() == IDOK )
			{
				Modified = TRUE;
				Length = EventName.GetLength() + 1;
			}
		}
		fwrite( &Length, 1, sizeof(Length),   DataBase );
		fwrite( (LPCSTR)EventName, 1, Length, DataBase );
		fwrite( &Record, 1, sizeof(Record),   DataBase );
	}
	
	fclose(DataBase);
	fclose(OldDatFile);
	_unlink(TempFileName);
	Events.ReadConfig();
	GetListCtrl().SetItemState(Selection, LVIS_SELECTED, LVIS_SELECTED);	
	GetListCtrl().EnsureVisible( Selection, FALSE);
}

void CReminderView::OnUpdateEditevent(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if( GetListCtrl().GetSelectedCount() == 0 )
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);
}

void CReminderView::OnUpdateDeleteevent(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if( GetListCtrl().GetSelectedCount() == 0 )
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);
}

void CReminderView::OnColumnclick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	if( LastHeader != pNMListView->iSubItem )
		Ascending = 1;
	LastHeader = pNMListView->iSubItem;
	Events.SetSortOrder(Ascending);
	Events.Sort(pNMListView->iSubItem);
	Ascending = !Ascending;
	*pResult = 0;
}

void CReminderView::OnDontremind() 
{
	// TODO: Add your command handler code here
	theApp.DontRemind = !theApp.DontRemind;
	HKEY hKey;
	DWORD Disposition;
	
	if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,"Software\\Microsoft\\Windows\\CurrentVersion\\Run",
		0,"",REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,&Disposition)==ERROR_SUCCESS)
	{
			//Writing to registry so that Reminder 2.0 will autorun on startup
		if( theApp.DontRemind )
		{
			RegDeleteValue (hKey, "Reminder" ); 
		}
		else
		{
			RegSetValueEx(hKey,"Reminder",0, REG_SZ,(const unsigned char *)(LPCSTR)theApp.AutoRunCommand,theApp.AutoRunCommand.GetLength());
		}
		//Deleting subkey Reminder
		//This is done to fix a bug in an earlier version 
		RegDeleteKey (hKey, "Reminder" ); 
		RegCloseKey(hKey);	
	}
	else
	{
		AfxMessageBox("Unable to create registry entry");
	}
	theApp.WriteProfileInt("Settings","DontRemind", theApp.DontRemind);
}

void CReminderView::OnUpdateDontremind(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(theApp.DontRemind);

}

void CReminderView::OnDestroy() 
{
	CListView::OnDestroy();
	
	// TODO: Add your message handler code here
	if( theApp.DontRemind )
	{
		if(AfxMessageBox("You have opted not to be reminded of the events.\r\nIs this what you want?",
			MB_YESNO) == IDNO )
		{
			OnDontremind() ;			
		}
	}
}
